unit VisibilityAETPD7_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Office2000, adxAddIn, VisibilityAETPD7_TLB, StdVcl,
  Classes, adxxlFormsManager;

type
  TCoVisibilityAETPD7 = class(TadxAddin, ICoVisibilityAETPD7)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    adxExcelTaskPanesManager1: TadxExcelTaskPanesManager;
    adxCommandBar1: TadxCommandBar;
    adxRibbonTab1: TadxRibbonTab;
    procedure adxCommandBar1Controls0Click(Sender: TObject);
    procedure adxRibbonTab1Controls0Controls0Click(Sender: TObject;
      const RibbonControl: IRibbonControl);
    procedure adxCOMAddInModuleCreate(Sender: TObject);
    procedure adxExcelTaskPanesManager1ADXInitialize(ASender: TObject;
      Args: TadxInitializeEventArgs);
    procedure adxCOMAddInModuleAddInStartupComplete(Sender: TObject);
  private
    FShowByButtonClick: boolean;
    function GetShowByButtonClick: boolean;
    procedure ProcessButtonClick;
    function GetRibbonButton: TadxRibbonButton;
    function GetCommandBarButton: TadxCommandBarButton;
  protected
  public
    procedure UpdateButton;
    property ShowByButtonClick: boolean read GetShowByButtonClick;
    property RibbonButton: TadxRibbonButton read GetRibbonButton;
    property CommandBarButton: TadxCommandBarButton read GetCommandBarButton; 
  end;

implementation

uses Unit1, uUtils;

{$R *.dfm}

procedure TAddInModule.adxCOMAddInModuleAddInStartupComplete(Sender: TObject);
begin
  UpdateButton();
end;

procedure TAddInModule.adxCOMAddInModuleCreate(Sender: TObject);
begin
  FShowByButtonClick := false;
end;

procedure TAddInModule.adxCommandBar1Controls0Click(Sender: TObject);
begin
  ProcessButtonClick();
end;

procedure TAddInModule.adxExcelTaskPanesManager1ADXInitialize(ASender: TObject;
  Args: TadxInitializeEventArgs);
begin
  ExcelUtils.InitExcelVersion(ExcelApp.DefaultInterface);
end;

procedure TAddInModule.adxRibbonTab1Controls0Controls0Click(Sender: TObject;
  const RibbonControl: IRibbonControl);
begin
  ProcessButtonClick();
end;

function TAddInModule.GetCommandBarButton: TadxCommandBarButton;
begin
  try
    result := adxCommandBar1.Controls[0] as TadxCommandBarButton;
  except
    result := nil;
  end;
end;

function TAddInModule.GetRibbonButton: TadxRibbonButton;
begin
  try
    result := ((adxRibbonTab1.Controls[0] as TadxRibbonGroup).Controls[0] as TadxRibbonButton);
  except
    result := nil;
  end;
end;

function TAddInModule.GetShowByButtonClick: boolean;
begin
  result := FShowByButtonClick;
end;

procedure TAddInModule.ProcessButtonClick;
var
  taskPane: TadxExcelTaskPane;
begin
  FShowByButtonClick := true;
  try
    taskPane := adxExcelTaskPanesManager1.Items[0].TaskPaneInstance;
    if (taskPane = nil) then begin
      taskPane := adxExcelTaskPanesManager1.Items[0].CreateTaskPaneInstance();
    end;
    if (taskPane <> nil) then begin
      taskPane.Show();
      UpdateButton();
    end;

  finally
      FShowByButtonClick := false;
  end;
end;

procedure TAddInModule.UpdateButton;
var
  TaskPane: TadxExcelTaskPane;
begin
  TaskPane := adxExcelTaskPanesManager1.Items[0].TaskPaneInstance;

  if (ExcelUtils.ExcelVersion = v2007) and (RibbonButton <> nil ) then begin
    if (TaskPane <> nil) then begin
      RibbonButton.Enabled := not TaskPane.Visible;
    end
    else begin
      RibbonButton.Enabled := true;
    end;
  end
  else begin
    if (TaskPane <> nil) then begin
      if (CommandBarButton <> nil) then begin
        CommandBarButton.Enabled := not TaskPane.Visible;
      end;
    end
    else begin
      CommandBarButton.Enabled := true;
    end;
  end;

end;

initialization
  TadxFactory.Create(ComServer, TCoVisibilityAETPD7, CLASS_CoVisibilityAETPD7, TAddInModule);

end.
